package cz.uhk.dod.data.api

import cz.uhk.dod.tools.installJsonSerialization
import cz.uhk.dod.tools.installLogging
import cz.uhk.dod.tools.installTimeout
import io.ktor.client.*
import io.ktor.client.plugins.*
import io.ktor.client.request.*
import io.ktor.http.*

interface DODApi {

    val httpClient: HttpClient

    suspend fun fieldOfStudy() = httpClient.get("field-of-study-info")

    suspend fun events() = httpClient.get("event")

    suspend fun videos() = httpClient.get("video")

    companion object {

        private const val BaseApiUrl = "http://10.0.2.2:8080/api/v1/"

        operator fun invoke() = object : DODApi {
            override val httpClient = HttpClient {
                installLogging() //logging to console
                installJsonSerialization()
                installTimeout()
                defaultRequest {
                    url(BaseApiUrl)
                    //headers
                    contentType(ContentType.Application.Json)
                    accept(ContentType.Application.Json)
                }
            }
        }
    }
}