package cz.uhk.dod.data.api.response

import cz.uhk.dod.data.db.FieldOfStudyEntity
import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable

@Serializable
data class FieldOfStudy(
    val degreeType: DegreeType,
    val items: List<FieldOfStudyInfo>,
)

@Serializable
data class FieldOfStudyInfo(
    val name: String,
    val shortCut: String,
    val degreeType: DegreeType,
    val formType: FormType,
    val studyPeriod: Int,
    val description: String,
    val candidateProfile: String,
    val graduateProfile: String,
    @SerialName("eapplicationFormUrl")
    val eApplicationFormUrl: String,
    val studyPlanUrl: String,
    val furtherStudyPossibility: String?,
    val examWaiverOption: String,
    val admissionProcedure: String?,
    val estimatedNumberOfAdmissions: Int,
    val accreditationUntil: String, // ToDo LocalDateTime,
//    val urlDocumentsToDownload: List<DocumentInfo>?,
) {

    fun toEntity() = FieldOfStudyEntity(
        name = name,
        shortCut = shortCut,
        degreeType = degreeType,
        formType = formType,
        studyPeriod = studyPeriod,
        description = description,
        candidateProfile = candidateProfile,
        graduateProfile = graduateProfile,
        eApplicationFormUrl = eApplicationFormUrl,
        studyPlanUrl = studyPlanUrl,
        furtherStudyPossibility = furtherStudyPossibility,
        examWaiverOption = examWaiverOption,
        admissionProcedure = admissionProcedure,
        estimatedNumberOfAdmissions = estimatedNumberOfAdmissions,
        accreditationUntil = accreditationUntil,
        urlDocumentsToDownload = null, // TODO
    )
}

@Serializable
data class DocumentInfo(
    val name: String,
    val url: String,
)

enum class DegreeType(val label: String) {
    BACHELOR("Bakalářský"),
    MASTER("Magisterský"),
    DOCTORAL("Doktorský"),
}

enum class FormType {
    PRESENT,
    DISTANCE
}
