package cz.uhk.dod.data.api.response

import cz.uhk.dod.data.db.EventEntity
import kotlinx.serialization.Serializable

@Serializable
data class UniversityEvent(
    val name: String,
    val type: UniversityEventType,
    val fromTime: String, // ToDo LocalDateTime,
    val toTime: String, // ToDo LocalDateTime,
    val location: String,
    val repetitionTimeInMinutes: Int?,
    val description: String,
) {
    fun toEntity() =
        EventEntity(
            name = name,
            type = type,
            fromTime = fromTime,
            toTime = toTime,
            location = location,
            repetitionTimeInMinutes = repetitionTimeInMinutes,
            description = description,
        )
}

enum class UniversityEventType(
    val label: String,
) {
    PRESENTATION("Přednášky"),
    SIDE_EVENT("Dopovodné akce"),
    WORKSHOP("Workshopy"),
}