package cz.uhk.dod.theme

import androidx.compose.material.Typography
import androidx.compose.ui.text.TextStyle
import androidx.compose.ui.text.font.Font
import androidx.compose.ui.text.font.FontFamily
import androidx.compose.ui.text.font.FontStyle
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.text.style.TextDecoration
import androidx.compose.ui.unit.em
import androidx.compose.ui.unit.sp
import cz.uhk.dod.R

val MSLondonFontFamily = FontFamily(
    Font(R.font.gradec_regular),
    Font(R.font.gradec_bold, weight = FontWeight.Bold),
)

private val BaseTextStyle = TextStyle(
    fontFamily = MSLondonFontFamily,
    fontWeight = FontWeight.W400,
    fontStyle = FontStyle.Normal,
    fontSize = 15.sp,
    lineHeight = 22.sp,
)

val TitleL = BaseTextStyle.copy(
    fontSize = 34.sp,
    lineHeight = 41.sp,
    fontWeight = FontWeight.W600,
)
val TitleM = BaseTextStyle.copy(
    fontSize = 26.sp,
    lineHeight = 31.sp,
    fontWeight = FontWeight.W600,
)
val TitleS = BaseTextStyle.copy(
    fontSize = 26.sp,
    lineHeight = 31.sp,
    fontWeight = FontWeight.W600,
)
val TitleSSemiBold = BaseTextStyle.copy(
    fontSize = 18.sp,
    lineHeight = 22.sp,
    fontWeight = FontWeight.W600,
)
val TextL = BaseTextStyle.copy(
    fontSize = 17.sp,
    lineHeight = 25.sp,
)
val TextLBold = BaseTextStyle.copy(
    fontSize = 17.sp,
    lineHeight = 22.sp,
    fontWeight = FontWeight.W700,
)
val TextM = BaseTextStyle.copy(
    fontSize = 15.sp,
    lineHeight = 22.sp,
)
val TextMBold = BaseTextStyle.copy(
    fontSize = 15.sp,
    lineHeight = 22.sp,
    fontWeight = FontWeight.W700,
)
val TextS = BaseTextStyle.copy(
    fontSize = 12.sp,
    lineHeight = 17.sp,
)
val TextSUnderlined = BaseTextStyle.copy(
    fontSize = 12.sp,
    lineHeight = 17.sp,
    textDecoration = TextDecoration.Underline,
)
val TextSBold = BaseTextStyle.copy(
    fontSize = 12.sp,
    lineHeight = 17.sp,
    fontWeight = FontWeight.W700,
)
val TextXSBold = BaseTextStyle.copy(
    fontSize = 11.sp,
    lineHeight = 16.sp,
    fontWeight = FontWeight.W700,
)
val TextCapitals = BaseTextStyle.copy(
    fontSize = 14.sp,
    lineHeight = 18.sp,
    letterSpacing = 0.22.em,
    fontWeight = FontWeight.W700,
    // Uppercase must be handled in code
)

// Set of Material typography styles to start with
val Typography = Typography(
    defaultFontFamily = MSLondonFontFamily,

    h1 = TitleL,
    h2 = TitleM,
    h3 = TitleS,

    h4 = TextLBold,
    h5 = TextMBold,
    h6 = TextSBold,

    subtitle1 = TextL,
    body1 = TextM,
    body2 = TextS,
    subtitle2 = TextXSBold, // Not correct

    button = TextMBold,
)

val Typography3 = androidx.compose.material3.Typography(

    headlineLarge = TitleL,
    headlineMedium = TitleL,
    headlineSmall = TitleL,

    titleLarge = TextLBold,
    titleMedium = TextMBold,
    titleSmall = TextSBold,

    bodyLarge = TextL,
    bodyMedium = TextM,
    bodySmall = TextS,

)