package cz.uhk.dod.ui

import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.foundation.isSystemInDarkTheme
import androidx.compose.material.MaterialTheme
import androidx.compose.material.Surface
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.toArgb
import androidx.core.view.WindowInsetsControllerCompat
import androidx.navigation.compose.rememberNavController
import cz.uhk.dod.theme.Fim3Theme
import cz.uhk.dod.theme.FimTheme

class MainActivity : ComponentActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContent {
            Fim3Theme {
                FimTheme {
                    //definice plátna
                    Surface(color = MaterialTheme.colors.background) {
                        //compose view
                        AppContainer(
                            controller = rememberNavController()
                        )
                    }
                    setupActivityUIBehavior(
                        backgroundColor = MaterialTheme.colors.background,
                        hasDarkUI = isSystemInDarkTheme(),
                    )
                }
            }
        }
    }
}


fun ComponentActivity.setupActivityUIBehavior(backgroundColor: Color, hasDarkUI: Boolean) {
    window.statusBarColor = backgroundColor.toArgb()
    window.navigationBarColor = backgroundColor.toArgb()
    WindowInsetsControllerCompat(window, window.decorView)
        .isAppearanceLightStatusBars = hasDarkUI.not()
}